set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Ashutosh Kumar
-- Create date: 29-July-2009
-- Description:	Committee Address Report
-- Parameters: @RotaryYear - RI Year Description e.g '2009-10'
-- =============================================
ALTER PROCEDURE  [dbo].[rpt_client_ri_committee_address_report]
@Start_date	datetime = NULL,
@End_date	datetime = NULL,
@Committee_name nvarchar(80) = NULL

--@Area_name nvarchar(1000) = NULL,
--@Zone_name nvarchar(36) = ''

--@RotaryYear    varchar(10) = NULL


AS
BEGIN
	--   	 @var int,
	--		 @Club_key nvarchar(36),
	--		 @DistList nvarchar(10),
	--		 @Full_DistList nvarchar(450),
	--		 @Zone_key nvarchar(36),
	--		 @Section_key nvarchar(36),
	declare	 @RiStart_date datetime,
			 @RiEnd_date datetime,
			 @Zone_in_Area nvarchar(10),
			 @Full_AreaList nvarchar(450),
			 @Zone_key nvarchar(36),
			 @Area_key nvarchar(36),
			 @var int,
			 @rowcnt int,
-- Start Added by Bhushan on 18-Sep-2009
@District nvarchar(10),
@Club nvarchar(10),
@Area nvarchar(10),
@Zone nvarchar(10),
@Member nvarchar(10)
-- End

print 'Start : ' + cast(getdate() as varchar)

	create table #tempResourceGrp_intermediate
		(
			 RotaryYear nvarchar(10),
			 CommitteeName nvarchar(80),
			 CommitteeDesc nvarchar(80),
			 Committee_Position nvarchar(50),
			 Name nvarchar(180),
			 Spouse_Name nvarchar(180),
			 Profession nvarchar(100),
			 Club_key nvarchar(36),
			 Organization_Name nvarchar(150),
			 Organization_Role nvarchar(50),
			 Address nvarchar(450),
			 City nvarchar(40),
			 State nvarchar(40),
			 Zip_Code nvarchar(20),
			 Country nvarchar(60),
			 Int_Prov nvarchar(150),
			 Fax_number nvarchar(55),
			 Email_Address nvarchar(75),
			 Language nvarchar(50),
			 Area_Description nvarchar(1000),
			 Area_Key nvarchar(36),
			 Zones_Associated_with_Area nvarchar(1000),
			 Zone_Name nvarchar(150),
			 Zone_key nvarchar(36),
			 Section_key nvarchar(36),
			 Section_Name nvarchar(150),	
			 cmc_key nvarchar(36),
			 Ind_Key nvarchar(36),
			 Ind_Name nvarchar(150),
			 Status nvarchar(150), 
			 Start_Date nvarchar(50),
			 End_Date nvarchar(50),
			 District_Number nvarchar(150)
		);

print 'Create table 1 : ' + cast(getdate() as varchar)

	create table #tempResourceGrp
		(
			 RotaryYear nvarchar(10),
			 CommitteeName nvarchar(80),
			 CommitteeDesc nvarchar(80),
			 Committee_Position nvarchar(50),
			 Name nvarchar(180),
			 Spouse_Name nvarchar(180),
			 Profession nvarchar(100),
			 Club_key nvarchar(36),
			 Organization_Name nvarchar(150),
			 Organization_Role nvarchar(50),
			 Address nvarchar(450),
			 City nvarchar(40),
			 State nvarchar(40),
			 Zip_Code nvarchar(20),
			 Country nvarchar(60),
			 Int_Prov nvarchar(150),
			 Fax_number nvarchar(55),
			 Email_Address nvarchar(75),
			 Language nvarchar(50),
			 Area_Description nvarchar(1000),
			 Area_Key nvarchar(36),
			 Zones_Associated_with_Area nvarchar(1000),
			 Zone_Name nvarchar(150),
			 Zone_key nvarchar(36),
			 Section_key nvarchar(36),
			 Section_Name nvarchar(150),	
			 cmc_key nvarchar(36),
			 Ind_Key nvarchar(36),
			 Ind_Name nvarchar(150),
			 Status nvarchar(150), 
			 Start_Date nvarchar(50),
			 End_Date nvarchar(50),
			 District_Number nvarchar(150)
		);

print 'Create table 2 : ' + cast(getdate() as varchar)

--		 set @var = 0

		set @RiStart_date = (select ristartdt from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@Start_date, 101)) between ristartdt and rienddt)
		set @RiEnd_date = (select rienddt from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@End_date, 101)) between ristartdt and rienddt)
-- Start Added by Bhushan on 18-Sep-2009
set @District = (select fws_value from fw_system_option (nolock) where fws_option = 'ClientRIOrgTypeDistrictCode')
set @Club = (select fws_value from fw_system_option (nolock) where fws_option = 'RIOrgTypeClubCode')
set @Area = (select fws_value from fw_system_option (nolock) where fws_option = 'ClientRIOrgTypeAreaCode')
set @Zone = (select fws_value from fw_system_option (nolock) where fws_option = 'ClientRIOrgTypeZoneCode')
set @Member = (select fws_value from fw_system_option (nolock) where fws_option = 'ClientRIRotarianRelationshipCode')
-- End

print 'Main Insertion starts : ' + cast(getdate() as varchar)

/*This is where whole processing time going*/

		Insert into #tempResourceGrp_intermediate
			(RotaryYear, CommitteeName, CommitteeDesc, Committee_Position, Name, Spouse_Name,
				Profession, Club_key, Organization_Name, Organization_Role, Address, City,
				State, Zip_Code, Country, Int_Prov, Fax_number, Email_Address, 
				Language, Area_Description, Area_Key, Zones_Associated_with_Area, Zone_Name, Zone_key, 
				Section_key, Section_Name,cmc_key,
				Ind_Key, Ind_Name, Status, Start_Date, End_Date, District_Number)
		--select * from ##ashu

		SELECT 
		[RotaryYear] = ((select Convert(varchar(4), RiStartYear) from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@Start_date, 101)) between ristartdt and rienddt) 
						+ '-' +
						(select right(Convert(varchar(4),RiEndYear),2)  from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@End_date, 101)) between ristartdt and rienddt)),
		[CommitteeName] = cmt_name,
		[CommitteeDesc] = cmt_description,
		[Committee_Position] = cpo_code,
		[Name] = Case when ind_first_name IS NULL then '' else ind_first_name end + ' ' + Case when ind_mid_name IS NULL then '' else left(ind_mid_name,1) end + ' ' + Case when ind_last_name IS NULL then '' else ind_last_name end,
		[Spouse_Name] = Case when ind_spouse_name IS NOT NULL then 'Spouse: ' + ind_spouse_name else '' end,
		[Profession] = Case when ind_ri_classification_ext IS NOT NULL then 'Profession: ' + ind_ri_classification_ext else '' end,
		[Club_key] = ixo_org_cst_key,
		[Organization_Name] = Case when cst_org_name_dn IS NOT NULL then 'Rotary Club of ' + cst_org_name_dn else '' end,
		[Organization_Role] = ixo_rlt_code,
		[Address] = (Case when adr_line1 IS NOT NULL then adr_line1 else '' end) + (Case when adr_line2 IS NOT NULL then ', ' + adr_line2 else '' end) + (Case when adr_line3 IS NOT NULL then ', ' + adr_line3 else '' end) ,
		[City] = Case when adr_city IS NOT NULL then ', ' + adr_city else '' end,
		[State] = Case when adr_state IS NOT NULL then ', ' + adr_state else '' end,
		[Zip_Code] = Case when adr_post_code IS NOT NULL then ', ' + adr_post_code else '' end,
		[Country] = Case when adr_country IS NOT NULL then ', ' + adr_country else '' end,
		[Int_Prov] = adr_intl_province,
		[Fax_number] = case when (case when cty_idd_code is null then cfx_fax_number_complete else fax_number end) IS NOT NULL then 'Fax: ' + (case when cty_idd_code is null then cfx_fax_number_complete else fax_number end) else '' end,  
		[Email_Address] = case when eml_address IS NOT NULL then 'E-mail: ' + eml_address else '' end,  
		--[Ind_Official_Language] = Case when RILang1.r00_language_name IS NOT NULL then 'Language: ' + RILang1.r00_language_name else NULL end,
		--[Org_Language] =  Case when RILang2.r00_language_name IS NOT NULL then 'Language: ' + RILang2.r00_language_name else NULL end,
		[Language] = Case when RILang1.r00_language_name IS NOT NULL then 'Language: ' + RILang1.r00_language_name else (Case when RILang2.r00_language_name IS NOT NULL then 'Language: ' + RILang2.r00_language_name else '' end) end,
		--[Area_Description] = org_legal_description_ext,
		[Area_Description] = Case when Area.org_legal_description_ext IS NOT NULL then Area.org_legal_description_ext collate SQL_Latin1_General_CP1_CI_AS else Area.Org_name_noaccent_ext end , 
		[Area_Key] = Area.org_cst_key_ext, -- r28_org_cst_key, 
		[Zones_Associated_with_Area] =  NULL, -- data yet to arrive
		[Zone_Name] = q21_zone_name,
		[Zone_key] = q21_zone_key,
		[Section_key] = q21_section_key,
		[Section_Name] = q21_section_name,
		cmc_key,
		[Ind_Key] = cmc_cst_key,
		[Ind_Name] = cst_sort_name_dn,
		[Status] = cmc_status,
		[Start_Date]=cmc_start_date,
		[End_Date]=cmc_end_date,
		[District_Number] = q21_district_name 
		FROM mb_committee_x_customer (nolock)    
		JOIN co_customer (nolock)     ON cst_key=cmc_cst_key 
		LEFT JOIN mb_committee_x_position (nolock)     ON cmc_cop_key = cop_key 
		LEFT JOIN mb_committee_position (nolock)     ON cop_cpo_key = cpo_key 
		LEFT JOIN mb_committee (nolock) ON cop_cmt_key = cmt_key
		LEFT JOIN co_individual (nolock) on ind_cst_key = cmc_cst_key 
		LEFT JOIN co_individual_ext (nolock) on ind_cst_key_ext = ind_cst_key 
		LEFT JOIN co_customer_x_address (nolock) on cst_cxa_key = cxa_key  and cxa_delete_flag = 0  --cst_cxa_key=cxa_key //condition confirms primary.
		LEFT JOIN co_address (nolock) on cxa_adr_key = adr_key  and adr_delete_flag = 0 and adr_bad_address_flag = 0  
		LEFT JOIN co_customer_x_fax on cst_cfx_key = cfx_key and cfx_delete_flag = 0   
		LEFT JOIN co_email (nolock) on cst_eml_key=eml_key and eml_delete_flag=0
		LEFT JOIN co_fax (nolock) ON cfx_fax_key = fax_key    
		LEFT JOIN co_country (nolock) ON fax_cty_key = cty_key 
		LEFT JOIN client_ri_language_ability (nolock) on r04_key = ind_r04_key_ext AND r04_ind_cst_key = ind_cst_key AND r04_delete_flag = 0
		LEFT JOIN client_ri_language (nolock) RILang1 on r04_r00_key = RILang1.r00_key and RILang1.r00_official_ri_flag = 1
		LEFT JOIN co_individual_x_organization (nolock) on ixo_key = cst_ixo_key AND ixo_rlt_code = @Member
			AND (( dbo.av_begin_of_day(ixo_start_date) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
					OR ( dbo.av_begin_of_day(ixo_start_date) < (select convert(datetime, convert(varchar(10),@RiStart_date, 101)))
						  AND ((dbo.av_begin_of_day(ixo_end_date) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
								OR ixo_end_date is NULL OR (convert(datetime, convert(varchar(10),ixo_end_date, 101))) > (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
					   ))			
			AND ixo_delete_flag = 0  
		LEFT JOIN co_customer_x_customer DistClbLst (nolock) on DistClbLst.cxc_cst_key_2 = ixo_org_cst_key 
			AND DistClbLst.cxc_rlt_code = @District
			AND DistClbLst.cxc_rlt_code2 = @Club
			AND (((convert(datetime, convert(varchar(10), DistClbLst.cxc_start_date, 101))) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
					OR ( (convert(datetime, convert(varchar(10), DistClbLst.cxc_start_date, 101))) < (select convert(datetime, convert(varchar(10),@RiStart_date, 101)))
						  AND (((convert(datetime, convert(varchar(10), DistClbLst.cxc_end_date, 101))) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
								OR DistClbLst.cxc_end_date is NULL OR (convert(datetime, convert(varchar(10), DistClbLst.cxc_end_date, 101))) > (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))	
					   ))	
			AND DistClbLst.cxc_delete_flag = 0		
		LEFT JOIN co_organization_ext (nolock) AreaCoor_DistDetails on AreaCoor_DistDetails.org_cst_key_ext = ixo_org_cst_key -- cxc_cst_key_1 
		--LEFT JOIN co_organization_ext (nolock) on org_cst_key_ext = cxc_cst_key_1 
		LEFT JOIN client_ri_language (nolock) RILang2 on RILang2.r00_key = org_language_ext
		LEFT JOIN vw_client_ri_club_flex_structure (nolock) on q21_club_key = ixo_org_cst_key
			AND (( dbo.av_begin_of_day(q21_effective_date) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
					OR ( dbo.av_begin_of_day(q21_effective_date) < (select convert(datetime, convert(varchar(10),@RiStart_date, 101)))
						  AND ((dbo.av_begin_of_day(q21_end_date) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
								OR q21_end_date is NULL OR dbo.av_begin_of_day(q21_end_date) > (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
					   ))
		LEFT JOIN client_ri_r28_committee_customer_x_organization (nolock) ON r28_cmc_key = cmc_key AND r28_delete_flag = 0
		LEFT JOIN co_customer_x_customer AreaLst (nolock) ON AreaLst.cxc_cst_key_1 = r28_org_cst_key -- Area Key NEW
			AND AreaLst.cxc_rlt_code = @Area
				AND AreaLst.cxc_rlt_code2 = @Zone
				AND (((convert(datetime, convert(varchar(10), AreaLst.cxc_start_date, 101))) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
						OR ( (convert(datetime, convert(varchar(10), AreaLst.cxc_start_date, 101))) < (select convert(datetime, convert(varchar(10),@RiStart_date, 101)))
							  AND (((convert(datetime, convert(varchar(10), AreaLst.cxc_end_date, 101))) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
									OR AreaLst.cxc_end_date is NULL)	
						   ))
				AND AreaLst.cxc_delete_flag = 0

		LEFT JOIN co_organization_ext Area (nolock) ON Area.org_cst_key_ext = r28_org_cst_key
			AND Area.org_cst_key_ext = AreaLst.cxc_cst_key_1
		--LEFT JOIN co_organization_ext Area (nolock) ON Area.org_cst_key_ext = AreaLst.cxc_cst_key_1 -- NEW
		WHERE cmc_csu_key is null 
		AND cmc_delete_flag=0
		AND (((convert(datetime, convert(varchar(10),cmc_start_date, 101))) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
				OR ( (convert(datetime, convert(varchar(10),cmc_start_date, 101))) < (select convert(datetime, convert(varchar(10),@RiStart_date, 101)))
					  AND (((convert(datetime, convert(varchar(10),cmc_end_date, 101))) between (select convert(datetime, convert(varchar(10),@RiStart_date, 101))) AND (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
							OR cmc_end_date is NULL OR (convert(datetime, convert(varchar(10),cmc_end_date, 101))) > (select convert(datetime, convert(varchar(10),@RiEnd_date, 101))))
				   ))
		and cpo_code in ('Zone Coordinator', 'Area Coordinator', 'Assistant General Coordinator', 'General Coordinator', 'Chairperson', 'Vice Chairperson', 'Member', 'Adviser', 'Liaison Director', 'Liaison Trustee')
		AND cmc_start_date between q21_effective_date and q21_end_date 
		AND cmc_end_date between q21_effective_date and q21_end_date	
		AND cmt_name = @Committee_name 

print '#tempResourceGrp_intermediate : ' + cast(getdate() as varchar)

		Insert into #tempResourceGrp
			(RotaryYear, CommitteeName, CommitteeDesc, Committee_Position, Name, Spouse_Name,
				Profession, Club_key, Organization_Name, Organization_Role, Address, City,
				State, Zip_Code, Country, Int_Prov, Fax_number, Email_Address, 
				Language, Area_Description, Area_Key, Zones_Associated_with_Area, Zone_Name, Zone_key, 
				Section_key, Section_Name,cmc_key,
				Ind_Key, Ind_Name, Status, Start_Date, End_Date, District_Number)
		select 
			RotaryYear, CommitteeName, CommitteeDesc, Committee_Position, Name, Spouse_Name,
				Profession, Club_key, Organization_Name, Organization_Role, Address, City,
				State, Zip_Code, Country, Int_Prov, Fax_number, Email_Address, 
				Language, Area_Description, Area_Key, Zones_Associated_with_Area, Zone_Name, Zone_key, 
				Section_key, Section_Name,cmc_key,
				Ind_Key, Ind_Name, Status, Start_Date, End_Date, District_Number 
		from #tempResourceGrp_intermediate 
		Group By RotaryYear, CommitteeName, CommitteeDesc, Committee_Position, Name, Spouse_Name,
				Profession, Club_key, Organization_Name, Organization_Role, Address, City,
				State, Zip_Code, Country, Int_Prov, Fax_number, Email_Address, 
				Language, Area_Description, Area_Key, Zones_Associated_with_Area, Zone_Name, Zone_key, 
				Section_key, Section_Name,cmc_key,
				Ind_Key, Ind_Name, Status, Start_Date, End_Date, District_Number

print '#tempResourceGrp : ' + cast(getdate() as varchar)

	--**********************************************************************************
	-- Find the first Home Phone and Business Phone for Ind_Key in #tempResourceGrp
	--**********************************************************************************

	select *,
	[Home_Phone] = 'Res: ' + (select top 1 case when cty_idd_code IS NULL then cph_phn_number_complete else phn_number end from co_customer cst (nolock)
							LEFT JOIN co_customer_x_phone (nolock) on cph_cst_key = cst.cst_key and cph_delete_flag = 0
							LEFT JOIN co_phone (nolock) ON cph_phn_key = phn_key 
							LEFT JOIN co_phone_type (nolock) on pht_key = cph_pht_key
							LEFT JOIN co_country (nolock) ON phn_cty_key = cty_key   
						where pht_code = 'Home'
						and cst.cst_key = RGrp.Ind_Key),
	[Business_Phone] = 'Bus: ' + (select top 1 case when cty_idd_code IS NULL then cph_phn_number_complete else phn_number end from co_customer cst (nolock)
							LEFT JOIN co_customer_x_phone (nolock) on cph_cst_key = cst.cst_key and cph_delete_flag = 0
							LEFT JOIN co_phone (nolock) ON cph_phn_key = phn_key 
							LEFT JOIN co_phone_type (nolock) on pht_key = cph_pht_key
							LEFT JOIN co_country (nolock) ON phn_cty_key = cty_key   
						where pht_code = 'Business'
						and cst.cst_key = RGrp.Ind_Key),
	[Cell_Phone] = 'Res: ' + (select top 1 case when cty_idd_code IS NULL then cph_phn_number_complete else phn_number end from co_customer cst (nolock)
							LEFT JOIN co_customer_x_phone (nolock) on cph_cst_key = cst.cst_key and cph_delete_flag = 0
							LEFT JOIN co_phone (nolock) ON cph_phn_key = phn_key 
							LEFT JOIN co_phone_type (nolock) on pht_key = cph_pht_key
							LEFT JOIN co_country (nolock) ON phn_cty_key = cty_key   
						where pht_code = 'Mobile'
						and cst.cst_key = RGrp.Ind_Key)
	into #temp_AreaList
	from #tempResourceGrp (nolock) RGrp

print '#temp_AreaList : ' + cast(getdate() as varchar)
	-- select * from #Temp;
	-- ************************************************************
	-- Establish all Area and Zone relationships for the committee
	-- ************************************************************

	select * 
		into #tmpArea_ZoneRelation
	from
	(select 
	--[ZonesInArea] =  Case when Zone.org_legal_description_ext IS NOT NULL then Zone.org_legal_description_ext collate SQL_Latin1_General_CP1_CI_AS else Zone.Org_name_noaccent_ext end ,
	[ZonesInArea] = Zone.Org_name_noaccent_ext ,
	[ZoneKey] = Zone.org_cst_key_ext,
	[Area] =  Case when Area.org_legal_description_ext IS NOT NULL then Area.org_legal_description_ext collate SQL_Latin1_General_CP1_CI_AS else Area.Org_name_noaccent_ext end, 
	[AreaKey] = Area.org_cst_key_ext
	from client_ri_r28_committee_customer_x_organization (nolock) 
	JOIN mb_committee_x_customer CommXCust (nolock) ON cmc_key =  r28_cmc_key  AND cmc_delete_flag = 0
	JOIN co_customer (nolock)     ON cst_key = CommXCust.cmc_cst_key 
	LEFT JOIN mb_committee_x_position (nolock)     ON CommXCust.cmc_cop_key = cop_key 
	LEFT JOIN mb_committee_position (nolock)     ON cop_cpo_key = cpo_key 
	LEFT JOIN mb_committee (nolock) ON cop_cmt_key = cmt_key
	LEFT JOIN co_customer_x_customer (nolock) ON cxc_cst_key_1 = r28_org_cst_key -- Area Key 
	LEFT JOIN co_organization_ext Zone (nolock) ON Zone.org_cst_key_ext = cxc_cst_key_2
	LEFT JOIN co_organization_ext Area (nolock) ON Area.org_cst_key_ext = cxc_cst_key_1
	where cmt_name = @Committee_name
	AND cxc_rlt_code = @Area
	AND cxc_rlt_code2 = @Zone
	AND ( cxc_start_date <= dbo.av_begin_of_day(getdate())			-- getdate() condition to find the current active Area - Zone linking
			AND (cxc_end_date > dbo.av_end_of_day(getdate()) OR cxc_end_date is NULL))
	AND cxc_delete_flag = 0
	AND r28_delete_flag = 0) temp
	--order by Convert(int,temp.ZonesInArea)

print '#tmpArea_ZoneRelation : ' + cast(getdate() as varchar)

	-- ****************************************************************
	-- List the Zones associated with Area
	-- ****************************************************************
	
	declare AreaList Cursor 
		for 
			select distinct(AreaKey) from #tmpArea_ZoneRelation	order by AreaKey

	Open AreaList 

	FETCH NEXT FROM AreaList INTO  @Area_key

	set @var = 0
	set @Zone_in_Area = ''

	WHILE @@FETCH_STATUS = 0
	BEGIN

		declare AreaZoneList Cursor 
			for 
				select ZonesInArea from #tmpArea_ZoneRelation where AreaKey = @Area_key
				order by Convert(int,ZonesInArea)

		open AreaZoneList
		
		FETCH NEXT FROM AreaZoneList INTO  @Zone_in_Area

		set @var = 0
		set @Full_AreaList = ''


		WHILE @@FETCH_STATUS = 0
		BEGIN
			If @Zone_in_Area IS NOT NULL
				BEGIN
					set @var = @var + 1
					If @var > 1 
						BEGIN
							set @Full_AreaList = @Full_AreaList + ', ' + @Zone_in_Area 
						END
					ELSE
						BEGIN
							set @Full_AreaList = 'Zones (' + @Full_AreaList + @Zone_in_Area
						END	
				END	
		--select '@SponClubList:' + @SponClubList
		FETCH NEXT FROM AreaZoneList into @Zone_in_Area
		--select 'Spon Club:' + @Sponsoring_Rotary_Club_Name

		END

		Update #temp_AreaList set Zones_Associated_with_Area = @Full_AreaList + ')'
		where Area_key = @Area_key
		

		CLOSE AreaZoneList
		DEALLOCATE AreaZoneList

		-- Get the next Area Key.
		FETCH NEXT FROM AreaList INTO  @Area_key

	END

	CLOSE AreaList
	DEALLOCATE AreaList

	SET @rowcnt = (select Count(1) from #temp_AreaList)

	-- ****************************************************************
	-- List Area -> Zone relationhip in a flat structure
	-- ****************************************************************
	IF (@rowcnt > 0)	
		BEGIN
			select  RotaryYear, CommitteeName, 
					[RIYearPos] = ((select Convert(varchar(4), RiStartYear) from fn_client_ri_all_rotary_years() where convert(datetime,Start_Date) between ristartdt and rienddt) 
									+ '-' +
									(select right(Convert(varchar(4),RiEndYear),2)  from fn_client_ri_all_rotary_years() where convert(datetime,End_Date) between ristartdt and rienddt)),
					CommitteeDesc, Committee_Position, Name, 
					[Spouse_Name] = Case when (select dbo.fn_client_ri_GetSpouseName(Ind_Key)) <> '' then (select 'Spouse:' + dbo.fn_client_ri_GetSpouseName(Ind_Key)) else Spouse_Name end,
					Profession, Club_key, Organization_Name, Organization_Role, Address, City,
					State, Zip_Code, Country, Int_Prov, Fax_number, Email_Address, 
					Language, 
					[Area_Description] = case when Area_Description IS NULL then Area else Area_Description end,  
					[Area_Key] = case when Area_Key IS NULL Then AreaKey else Area_Key end, 
					[Zones_Associated_with_Area], 
					Zone_Name,  [Zone_Description] = (select case when org_legal_description_ext IS NULL then org_name_noaccent_ext else org_legal_description_ext collate SQL_Latin1_General_CP1_CI_AS end from co_organization_ext (nolock) where org_cst_key_ext = Zone_Key), Zone_key, 
					Section_key, Section_Name, [cmc_key] = grp.cmc_key,
					Ind_Key, Ind_Name, Status, Start_Date, End_Date, District_Number, 
					Home_Phone, Business_Phone, Cell_Phone
			from #temp_AreaList grp
			LEFT JOIN #tmpArea_ZoneRelation (nolock) ON Zone_Key = ZoneKey
			order by Convert(int,Zone_Name), Section_Name
		END
	ELSE
		BEGIN
		
			select 
					[RotaryYear] = ((select Convert(varchar(4), RiStartYear) from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@Start_date, 101)) between ristartdt and rienddt) 
						+ '-' +
						(select right(Convert(varchar(4),RiEndYear),2)  from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@End_date, 101)) between ristartdt and rienddt)),
					CommitteeName = '', 
					[RIYearPos] = ((select Convert(varchar(4), RiStartYear) from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@Start_date, 101)) between ristartdt and rienddt) 
						+ '-' +
						(select right(Convert(varchar(4),RiEndYear),2)  from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),@End_date, 101)) between ristartdt and rienddt)),
					CommitteeDesc = '', Committee_Position = '', Name = '', Spouse_Name = '',
					Profession = '', Club_key = '', Organization_Name = '', Organization_Role = '', Address = '', City = '',
					State = '', Zip_Code = '', Country = '', Int_Prov = '', Fax_number = '', Email_Address = '', 
					Language = '', Area_Description = '', Area_Key = '',
					Zones_Associated_with_Area = '', Zone_Name = '',  Zone_Description = '', Zone_key = '', 
					Section_key = '', Section_Name = '', cmc_key = '',
					Ind_Key = '', Ind_Name = '', Status = '', Start_Date = '', End_Date = '', District_Number = '', 
					Home_Phone = '', Business_Phone = '', Cell_Phone = ''
			from fn_client_ri_all_rotary_years() where convert(datetime,CalYear) = dbo.av_begin_of_day(getdate())
		END	

END

print 'End : ' + cast(getdate() as varchar)

