/*-- inputs are as listed below
1. '01/07/2009'
2. '06/30/2010'
3. '2010 International Assembly Committee'
*/

SELECT
[RotaryYear] = ((select Convert(varchar(4), RiStartYear) from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),'01/07/2009', 101)) between ristartdt and rienddt) 
				+ '-' +
				(select right(Convert(varchar(4),RiEndYear),2)  from fn_client_ri_all_rotary_years() where convert(datetime, convert(varchar(10),'06/30/2010', 101)) between ristartdt and rienddt)),
[CommitteeName] = cmt_name,
[CommitteeDesc] = cmt_description,
[Committee_Position] = cpo_code,
[Name] = Case when ind_first_name IS NULL then '' else ind_first_name end + ' ' + Case when ind_mid_name IS NULL then '' else left(ind_mid_name,1) end + ' ' + Case when ind_last_name IS NULL then '' else ind_last_name end,
[Spouse_Name] = Case when ind_spouse_name IS NOT NULL then 'Spouse: ' + ind_spouse_name else '' end,
[Profession] = Case when ind_ri_classification_ext IS NOT NULL then 'Profession: ' + ind_ri_classification_ext else '' end,
[Club_key] = ixo_org_cst_key,
[Organization_Name] = Case when cst_org_name_dn IS NOT NULL then 'Rotary Club of ' + cst_org_name_dn else '' end,
[Organization_Role] = ixo_rlt_code,
[Address] = (Case when adr_line1 IS NOT NULL then adr_line1 else '' end) + (Case when adr_line2 IS NOT NULL then ', ' + adr_line2 else '' end) + (Case when adr_line3 IS NOT NULL then ', ' + adr_line3 else '' end) ,
[City] = Case when adr_city IS NOT NULL then ', ' + adr_city else '' end,
[State] = Case when adr_state IS NOT NULL then ', ' + adr_state else '' end,
[Zip_Code] = Case when adr_post_code IS NOT NULL then ', ' + adr_post_code else '' end,
[Country] = Case when adr_country IS NOT NULL then ', ' + adr_country else '' end,
[Int_Prov] = adr_intl_province,
[Fax_number] = case when (case when cty_idd_code is null then cfx_fax_number_complete else fax_number end) IS NOT NULL then 'Fax: ' + (case when cty_idd_code is null then cfx_fax_number_complete else fax_number end) else '' end,  
[Email_Address] = case when eml_address IS NOT NULL then 'E-mail: ' + eml_address else '' end,  
[Language] = Case when RILang1.r00_language_name IS NOT NULL then 'Language: ' + RILang1.r00_language_name else (Case when RILang2.r00_language_name IS NOT NULL then 'Language: ' + RILang2.r00_language_name else '' end) end,
[Area_Description] = Case when Area.org_legal_description_ext IS NOT NULL then Area.org_legal_description_ext collate SQL_Latin1_General_CP1_CI_AS else Area.Org_name_noaccent_ext end , 
[Area_Key] = Area.org_cst_key_ext, 
[Zones_Associated_with_Area] =  NULL, 
[Zone_Name] = q21_zone_name,
[Zone_key] = q21_zone_key,
[Section_key] = q21_section_key,
[Section_Name] = q21_section_name,
cmc_key,
[Ind_Key] = cmc_cst_key,
[Ind_Name] = cst_sort_name_dn,
[Status] = cmc_status,
[Start_Date]=cmc_start_date,
[End_Date]=cmc_end_date,
[District_Number] = q21_district_name
FROM mb_committee_x_customer (nolock)    
JOIN co_customer (nolock)     ON cst_key=cmc_cst_key 
LEFT JOIN mb_committee_x_position (nolock)     ON cmc_cop_key = cop_key 
LEFT JOIN mb_committee_position (nolock)     ON cop_cpo_key = cpo_key 
LEFT JOIN mb_committee (nolock) ON cop_cmt_key = cmt_key
LEFT JOIN co_individual (nolock) on ind_cst_key = cmc_cst_key 
LEFT JOIN co_individual_ext (nolock) on ind_cst_key_ext = ind_cst_key 
LEFT JOIN co_customer_x_address (nolock) on cst_cxa_key = cxa_key  and cxa_delete_flag = 0 
LEFT JOIN co_address (nolock) on cxa_adr_key = adr_key  and adr_delete_flag = 0 and adr_bad_address_flag = 0  
LEFT JOIN co_customer_x_fax on cst_cfx_key = cfx_key and cfx_delete_flag = 0   
LEFT JOIN co_email (nolock) on cst_eml_key=eml_key and eml_delete_flag=0
LEFT JOIN co_fax (nolock) ON cfx_fax_key = fax_key    
LEFT JOIN co_country (nolock) ON fax_cty_key = cty_key 
LEFT JOIN client_ri_language_ability (nolock) on r04_key = ind_r04_key_ext AND r04_ind_cst_key = ind_cst_key AND r04_delete_flag = 0
LEFT JOIN client_ri_language (nolock) RILang1 on r04_r00_key = RILang1.r00_key and RILang1.r00_official_ri_flag = 1
LEFT JOIN co_individual_x_organization (nolock) on ixo_key = cst_ixo_key AND ixo_rlt_code = 'Member'
	AND (( dbo.av_begin_of_day(ixo_start_date) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
			OR ( dbo.av_begin_of_day(ixo_start_date) < (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101)))
				  AND ((dbo.av_begin_of_day(ixo_end_date) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
						OR ixo_end_date is NULL OR (convert(datetime, convert(varchar(10),ixo_end_date, 101))) > (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
			   ))			
	AND ixo_delete_flag = 0  
LEFT JOIN co_customer_x_customer DistClbLst (nolock) on DistClbLst.cxc_cst_key_2 = ixo_org_cst_key 
	AND DistClbLst.cxc_rlt_code = 'District'
	AND DistClbLst.cxc_rlt_code2 = 'Club'
	AND (((convert(datetime, convert(varchar(10), DistClbLst.cxc_start_date, 101))) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
			OR ( (convert(datetime, convert(varchar(10), DistClbLst.cxc_start_date, 101))) < (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101)))
				  AND (((convert(datetime, convert(varchar(10), DistClbLst.cxc_end_date, 101))) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
						OR DistClbLst.cxc_end_date is NULL OR (convert(datetime, convert(varchar(10), DistClbLst.cxc_end_date, 101))) > (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))	
			   ))	
	AND DistClbLst.cxc_delete_flag = 0		
LEFT JOIN co_organization_ext (nolock) AreaCoor_DistDetails on AreaCoor_DistDetails.org_cst_key_ext = ixo_org_cst_key -- cxc_cst_key_1 
LEFT JOIN client_ri_language (nolock) RILang2 on RILang2.r00_key = org_language_ext
LEFT JOIN vw_client_ri_club_flex_structure (nolock) on q21_club_key = ixo_org_cst_key
	AND (( dbo.av_begin_of_day(q21_effective_date) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
			OR ( dbo.av_begin_of_day(q21_effective_date) < (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101)))
				  AND ((dbo.av_begin_of_day(q21_end_date) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
						OR q21_end_date is NULL OR dbo.av_begin_of_day(q21_end_date) > (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
			   ))
LEFT JOIN client_ri_r28_committee_customer_x_organization (nolock) ON r28_cmc_key = cmc_key AND r28_delete_flag = 0
LEFT JOIN co_customer_x_customer AreaLst (nolock) ON AreaLst.cxc_cst_key_1 = r28_org_cst_key 
	AND AreaLst.cxc_rlt_code = 'Area'
		AND AreaLst.cxc_rlt_code2 = 'Zone'
		AND (((convert(datetime, convert(varchar(10), AreaLst.cxc_start_date, 101))) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
				OR ( (convert(datetime, convert(varchar(10), AreaLst.cxc_start_date, 101))) < (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101)))
					  AND (((convert(datetime, convert(varchar(10), AreaLst.cxc_end_date, 101))) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
							OR AreaLst.cxc_end_date is NULL)	
				   ))
		AND AreaLst.cxc_delete_flag = 0

LEFT JOIN co_organization_ext Area (nolock) ON Area.org_cst_key_ext = r28_org_cst_key
	AND Area.org_cst_key_ext = AreaLst.cxc_cst_key_1
WHERE cmc_csu_key is null 
AND cmc_delete_flag=0
AND (((convert(datetime, convert(varchar(10),cmc_start_date, 101))) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
		OR ( (convert(datetime, convert(varchar(10),cmc_start_date, 101))) < (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101)))
			  AND (((convert(datetime, convert(varchar(10),cmc_end_date, 101))) between (select convert(datetime, convert(varchar(10),'2008-07-01 00:00:00.000', 101))) AND (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
					OR cmc_end_date is NULL OR (convert(datetime, convert(varchar(10),cmc_end_date, 101))) > (select convert(datetime, convert(varchar(10),'2010-06-30 00:00:00.000', 101))))
		   ))
and cpo_code in ('Zone Coordinator', 'Area Coordinator', 'Assistant General Coordinator', 'General Coordinator', 'Chairperson', 'Vice Chairperson', 'Member', 'Adviser', 'Liaison Director', 'Liaison Trustee')
AND cmc_start_date between q21_effective_date and q21_end_date 
AND cmc_end_date between q21_effective_date and q21_end_date	
AND cmt_name = '2010 International Assembly Committee'